%define anolis_release 2

%global scons scons-3
%global scons_pkg python3-scons

Name:           libserf
Version:        1.3.9
Release:        %{anolis_release}%{?dist}
Summary:        High-Performance Asynchronous HTTP Client Library
License:        ASL 2.0
URL:            http://serf.apache.org/
Source0:        https://archive.apache.org/dist/serf/serf-%{version}.tar.bz2
BuildRequires:  gcc, %{scons_pkg}, pkgconfig
BuildRequires:  apr-devel, apr-util-devel, krb5-devel, openssl-devel
BuildRequires:  zlib-devel
Patch0:         %{name}-norpath.patch
Patch1:         %{name}-python3.patch
Patch2:         %{name}-1.3.9-bio-ctrl.patch
Patch3:         %{name}-1.3.9-errgetfunc.patch
Patch4:         %{name}-1.3.9-multihome.patch
Patch5:         %{name}-1.3.9-cmake.patch
Patch6:         %{name}-1.3.9-testsuite.patch

%description
The serf library is a C-based HTTP client library built upon the Apache 
Portable Runtime (APR) library. It multiplexes connections, running the
read/write communication asynchronously. Memory copies and transformations are
kept to a minimum to provide high performance operation.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       apr-devel

%description    devel
This package contains libraries and header files for
developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n serf-%{version} -p1

# Shared library versioning support in scons is worse than awful...
# minimally, here fix the soname to match serf-1.2.x.  Minor version
# handling should be fixed too; really requires better upstream support:
# http://scons.tigris.org/issues/show_bug.cgi?id=2869
sed -i '/SHLIBVERSION/s/MAJOR/0/' SConstruct

%build
%{scons} \
      CFLAGS="%{optflags}" \
      LINKFLAGS="%{__global_ldflags}" \
      PREFIX=%{_prefix} \
      LIBDIR=%{_libdir} \
      GSSAPI=%{_prefix} \
      %{?_smp_mflags}

%install
%{scons} install --install-sandbox=%{buildroot}

find %{buildroot}%{_libdir} -type f -name '*.*a' -delete -print

%generate_compatibility_deps

%check
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
%{scons} %{?_smp_mflags} check || true

%ldconfig_scriptlets

%files
%dir %{abidir}
%license LICENSE NOTICE
%{_libdir}/*.so.*
%{abidir}/*.dump

%files devel
%{_includedir}/serf-1/
%{_libdir}/*.so
%{_libdir}/pkgconfig/serf*.pc

%files doc
%doc CHANGES README design-guide.txt

%changelog
* Sat Mar 04 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 1.3.9-2
- optimize the spec file

* Tue Jun 14 2022 happy_orange <songnannan@linux.alibaba.com> - 1.3.9-1
- init from upstream
